## ocaml-visitors 20170404

=== src/Makefile ===
# ------------------------------------------------------------------------------

# Variables.

PACKAGE := \
  visitors

PLUGIN := \
  ppx_deriving_$(PACKAGE)

RUNTIME := \
  VisitorsRuntime

OCAMLBUILD := \
  ocamlbuild \
  -use-ocamlfind \
  -classic-display \
  -plugin-tag 'package(cppo_ocamlbuild)' \

# The targets that should be built (using ocamlbuild).
# Not sure whether all of the following files are really required.
TARGET := \
  $(patsubst %,$(PLUGIN).%,a cma cmxa cmxs) \
  $(patsubst %,$(RUNTIME).%,a cma cmi cmo cmx cmxa o) \

# The files that should be installed (using ocamlfind).
FILES := \
  META \
  Makefile.preprocess \
  $(patsubst %,_build/%,$(TARGET)) \

# ------------------------------------------------------------------------------

# Rules.

.PHONY: all clean install uninstall reinstall

all:
	$(OCAMLBUILD) $(TARGET)

clean:
	rm -f *~
	$(OCAMLBUILD) -clean

install: all
	ocamlfind install $(PACKAGE) $(FILES)

# [make uninstall] attempts to uninstall, but succeeds even if uninstallation
# fails (probably because the package was not installed in the first place).
uninstall:
	ocamlfind remove $(PACKAGE) || true

reinstall: uninstall
	@ $(MAKE) install

=== debian/changelog ===
ocaml-visitors (20170404-1ubuntu1) artful; urgency=medium

  * Add ocamlbuild build-dep.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 27 Jul 2017 12:04:41 +0100

ocaml-visitors (20170404-1build1) artful; urgency=high

  * No change rebuild against new findlib.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 27 Jul 2017 09:44:53 +0100

ocaml-visitors (20170404-1) unstable; urgency=medium

  * Initial upload (closes: #862775)

 -- Ralf Treinen <treinen@debian.org>  Thu, 06 Jul 2017 12:52:24 +0200

=== debian/control ===
Source: ocaml-visitors
Section: ocaml
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Ralf Treinen <treinen@debian.org>,
Build-Depends: debhelper (>= 10), dh-ocaml (>= 0.9~),
 ocaml-nox (>= 4.02.2), libfindlib-ocaml, cppo,
 libppx-deriving-ocaml-dev, ocamlbuild
Build-Depends-Indep: texlive-latex-base, latexmk,
 lmodern, texlive-fonts-recommended, texlive-latex-extra,
 ocp-indent
Standards-Version: 4.0.0
Homepage: https://gitlab.inria.fr/fpottier/visitors
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/ocaml-visitors.git
Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-visitors.git

Package: libppx-visitors-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Description: OCaml syntax extension for object-oriented visitors
 Visitors is a syntax extension for the OCaml programming language. It
 allows you to annotate your type definitions, such that a visitor class
 will be automatically generated. This visitor class contains methods
 for the traversal of your data structure, like iter, map, fold, etc. It
 is then easy to override these methods for your needs. This is very
 convenient when programming with complex algebraic data structures.

Package: libppx-visitors-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation of the visitors syntax extension for OCaml 
 This package contains the documentation of the visitors syntax extension
 for the OCaml programming language.

## ocaml-visitors 20170725

=== Makefile ===
.PHONY: all clean install uninstall reinstall

all clean install uninstall reinstall:
	$(MAKE) -C src $@

=== doc/Makefile ===
export VISITORS_BUILDING_DOCUMENTATION=true

include ../src/Makefile.preprocess

export TEXINPUTS=.:../test:

.PHONY: all loop clean

all: main.pdf

SOURCES   := $(wildcard *.tex) $(wildcard *.bib) $(wildcard *.sty)
ML        := $(shell ls ../test/*.ml | grep -v processed)
PROCESSED := $(patsubst %.ml,%.processed.ml,$(ML))

%.pdf: %.tex $(SOURCES) $(ML) $(PROCESSED)
	pdflatex $*
	bibtex $*
	pdflatex $*
	pdflatex $*

loop: $(SOURCES) $(ML) $(PROCESSED)
	latexmk -pdf -pvc main

clean:
	rm -f *.log *.aux *.bbl *.blg *.out *.toc *~ main.pdf

=== test/Makefile ===
# ocamlbuild options.
OCAMLBUILD := ocamlbuild -use-ocamlfind -classic-display

# For consistency with doc/Makefile, which relies on the same set of
# %.processed.ml files, we set this variable to true.
export VISITORS_BUILDING_DOCUMENTATION=true

# The source files.
TESTS := $(shell ls *.ml | grep -v processed)

# ------------------------------------------------------------------------------

.PHONY: test reinstall coverage bench mli processed clean

# Because ocamlbuild is not good at parallel builds, we have broken up the set
# of test sources into several subsets, each of which is described by an
# [.mllib] file. For each such file, we make a separate ocamlbuild invocation,
# and we let [make] run these invocations in parallel. (Each of them must use
# a distinct build directory, and ignore everyone else's build directory.)

test: reinstall
	@ echo Compiling...
	@ make -j4 $(patsubst %.mllib,%.cma,$(shell ls *.mllib))

%.cma:
	@ $(OCAMLBUILD) -build-dir _build_$* $@

# To ensure that we always have the current version of [visitors], we
# reinstall it before compiling.

reinstall:
	@ echo Re-installing...
	@ make -C ../src reinstall >/dev/null 2>/dev/null

# Checking that every .ml file is covered by one .mllib file.

coverage:
	@ for i in $(TESTS) ; do \
	  if ! grep -iw `basename $$i .ml` *.mllib >/dev/null ; then \
	    echo [ERROR] $$i is not covered by any .mllib file. ; \
	  fi \
	done

# ------------------------------------------------------------------------------

# A tiny speed benchmark.

bench: reinstall
	@ $(OCAMLBUILD) -build-dir _build_bench bench.native
	@ echo Running...
	@ _build_bench/bench.native

# Building an executable.

%.native:
	@ $(OCAMLBUILD) -build-dir \
	    _build_$(shell grep -iw $* *.mllib | sed -e 's/\([^.]*\).mllib:.*/\1/') \
	    $@

# ------------------------------------------------------------------------------

# Building inferred .mli files.

mli: reinstall
	make -j4 $(patsubst %.ml,%.inferred.mli,$(TESTS))

# This one is a bit tricky, as we must specify the right build directory.
# We grep to find out which .mllib file covers the desired .mli file,
# then construct the name of the build directory from the name of the
# .mllib file.

%.inferred.mli:
	@ $(OCAMLBUILD) -build-dir \
	    _build_$(shell grep -iw $* *.mllib | sed -e 's/\([^.]*\).mllib:.*/\1/') \
	    $@

# ------------------------------------------------------------------------------

# Preprocessing all source files.

processed: reinstall
	make -j4 -f ../src/Makefile.preprocess \
	  $(patsubst %.ml,%.processed.ml,$(TESTS))

# ------------------------------------------------------------------------------

# Cleaning up.

clean:
	@ rm -f *~
	@ rm -f *.processed.ml
	@ rm -rf _build*

# ------------------------------------------------------------------------------

=== debian/changelog ===
ocaml-visitors (20170725-2) unstable; urgency=medium

  * Patch ocaml-4.05: migrate to ocaml 4.05, patch picked from upstream git
    (closes: #880063)
  * Standards-Version 4.1.1:
    - replace Priority extra by optional. 

 -- Ralf Treinen <treinen@debian.org>  Mon, 30 Oct 2017 20:22:58 +0100

ocaml-visitors (20170725-1) unstable; urgency=medium

  * New upstream release. This release fixes compilation on bytecode
    architectures (closes: #869207)
  * Added build-dependency on ocamlbuild.

 -- Ralf Treinen <treinen@debian.org>  Fri, 28 Jul 2017 22:32:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: ocaml-visitors
 Section: ocaml
-Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Priority: optional
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>,
 Build-Depends: debhelper (>= 10), dh-ocaml (>= 0.9~),
- ocaml-nox (>= 4.02.2), libfindlib-ocaml, cppo,
- libppx-deriving-ocaml-dev, ocamlbuild
+ ocaml-nox (>= 4.02.2), libfindlib-ocaml, cppo, ocamlbuild,
+ libppx-deriving-ocaml-dev
 Build-Depends-Indep: texlive-latex-base, latexmk,
  lmodern, texlive-fonts-recommended, texlive-latex-extra,
  ocp-indent
-Standards-Version: 4.0.0
+Standards-Version: 4.1.1
 Homepage: https://gitlab.inria.fr/fpottier/visitors
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/ocaml-visitors.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-visitors.git

=== debian/rules ===
#!/usr/bin/make -f

ODESTDIR = $(CURDIR)/debian/libppx-visitors-ocaml-dev/usr/lib/ocaml

%:
	dh $@ --with ocaml

override_dh_auto_build:
	# do nothing

build-arch:
	$(MAKE)

build-indep:
	cd doc && $(MAKE) 

override_dh_auto_install:
	# do nothing

override_dh_install-arch:
	mkdir -p $(ODESTDIR)
	OCAMLFIND_DESTDIR=$(ODESTDIR) make install

override_dh_install-indep:
	dh_installdocs -i

override_dh_auto_test:
	# do nothing

=== debian/tests/control ===
Tests: weight
Depends: @, ocaml-nox, libfindlib-ocaml

## ocaml-visitors 20180306

=== debian/changelog ===
ocaml-visitors (20180306-3) unstable; urgency=medium

  * autopkgtest: depends on ocamlbuild
  * libppx-visitors-ocaml-dev: suggests -doc package.

 -- Ralf Treinen <treinen@debian.org>  Wed, 11 Jul 2018 07:59:45 +0200

ocaml-visitors (20180306-2) unstable; urgency=medium

  * Vcs-{Browser,Git}: update to salsa.
  * Standards-Version 4.1.5 (no change)

 -- Ralf Treinen <treinen@debian.org>  Mon, 09 Jul 2018 21:07:17 +0200

ocaml-visitors (20180306-1) unstable; urgency=medium

  * New upstream version.
    - dropped patch ocaml-4.05 since issue is solved upstream.
  * Standards-Version 4.1.3:
    - d/copyright: use https in format specifier
  * debhelper compatibility level 11:
    - fixed file location in libppx-visitors-ocaml-doc.doc-base since
      dh_installdocs now installs into the /usr/share/doc of the main
      package.
  * Add minimal version of build-dependency libppx-deriving-ocaml-dev.

 -- Ralf Treinen <treinen@debian.org>  Wed, 21 Mar 2018 20:43:06 +0100

=== debian/control ===
--- 
+++ 
@@ -3,21 +3,22 @@
 Priority: optional
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>,
-Build-Depends: debhelper (>= 10), dh-ocaml (>= 0.9~),
+Build-Depends: debhelper (>= 11), dh-ocaml (>= 0.9~),
  ocaml-nox (>= 4.02.2), libfindlib-ocaml, cppo, ocamlbuild,
- libppx-deriving-ocaml-dev
+ libppx-deriving-ocaml-dev (>= 4.0)
 Build-Depends-Indep: texlive-latex-base, latexmk,
  lmodern, texlive-fonts-recommended, texlive-latex-extra,
  ocp-indent
-Standards-Version: 4.1.1
+Standards-Version: 4.1.5
 Homepage: https://gitlab.inria.fr/fpottier/visitors
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/ocaml-visitors.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/ocaml-visitors.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-visitors
+Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-visitors.git
 
 Package: libppx-visitors-ocaml-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Provides: ${ocaml:Provides}
+Suggests: libppx-visitors-ocaml-doc
 Description: OCaml syntax extension for object-oriented visitors
  Visitors is a syntax extension for the OCaml programming language. It
  allows you to annotate your type definitions, such that a visitor class

## ocaml-visitors 20180513

=== src/Makefile ===
--- 
+++ 
@@ -17,17 +17,29 @@
   -classic-display \
   -plugin-tag 'package(cppo_ocamlbuild)' \
 
+# Detect whether ocamlopt is available.
+NATIVE := $(shell if env ocamlopt >/dev/null 2>/dev/null ; then \
+                  echo yes ; else echo no ; fi)
+
 # The targets that should be built (using ocamlbuild).
 # Not sure whether all of the following files are really required.
-TARGET := \
-  $(patsubst %,$(PLUGIN).%,a cma cmxa cmxs) \
-  $(patsubst %,$(RUNTIME).%,a cma cmi cmo cmx cmxa o) \
+ifeq ($(NATIVE),yes)
+  MSG := "Compiling for byte code and native code."
+  TARGETS := \
+    $(patsubst %,$(PLUGIN).%,cma a cmxa cmxs) \
+    $(patsubst %,$(RUNTIME).%,cmi cmo cma a cmx cmxa o)
+else
+  MSG := "Compiling for byte code only."
+  TARGETS := \
+    $(patsubst %,$(PLUGIN).%,cma) \
+    $(patsubst %,$(RUNTIME).%,cmi cmo cma)
+endif
 
 # The files that should be installed (using ocamlfind).
 FILES := \
   META \
   Makefile.preprocess \
-  $(patsubst %,_build/%,$(TARGET)) \
+  $(patsubst %,_build/%,$(TARGETS)) \
 
 # ------------------------------------------------------------------------------
 
@@ -36,7 +48,8 @@
 .PHONY: all clean install uninstall reinstall
 
 all:
-	$(OCAMLBUILD) $(TARGET)
+	@ echo $(MSG)
+	$(OCAMLBUILD) $(TARGETS)
 
 clean:
 	rm -f *~

=== debian/changelog ===
ocaml-visitors (20180513-1) unstable; urgency=medium

  * New upstream version.  This version allows projects using the -dev
    package to build under dune.
  * Build-depend on debhelper-compat (=12)

 -- Ralf Treinen <treinen@debian.org>  Mon, 18 Feb 2019 20:38:44 +0100

ocaml-visitors (20180306-4) unstable; urgency=medium

  * Standards-Version 4.3.0 (no change)
  * Debhelper compatibility level 12 (no change)
  * -dev package Suggests ocaml-findlib since package has a META file
  * Remove trailing white space in debian/{changelog,rules,control}

 -- Ralf Treinen <treinen@debian.org>  Tue, 08 Jan 2019 21:26:16 +0100

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Priority: optional
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>,
-Build-Depends: debhelper (>= 11), dh-ocaml (>= 0.9~),
+Build-Depends: debhelper-compat (= 12), dh-ocaml (>= 0.9~),
  ocaml-nox (>= 4.02.2), libfindlib-ocaml, cppo, ocamlbuild,
  libppx-deriving-ocaml-dev (>= 4.0)
 Build-Depends-Indep: texlive-latex-base, latexmk,
  lmodern, texlive-fonts-recommended, texlive-latex-extra,
  ocp-indent
-Standards-Version: 4.1.5
+Standards-Version: 4.3.0
 Homepage: https://gitlab.inria.fr/fpottier/visitors
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-visitors
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-visitors.git
@@ -18,7 +18,7 @@
 Architecture: any
 Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Provides: ${ocaml:Provides}
-Suggests: libppx-visitors-ocaml-doc
+Suggests: libppx-visitors-ocaml-doc, ocaml-findlib
 Description: OCaml syntax extension for object-oriented visitors
  Visitors is a syntax extension for the OCaml programming language. It
  allows you to annotate your type definitions, such that a visitor class
@@ -31,6 +31,6 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
-Description: Documentation of the visitors syntax extension for OCaml 
+Description: Documentation of the visitors syntax extension for OCaml
  This package contains the documentation of the visitors syntax extension
  for the OCaml programming language.

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 	$(MAKE)
 
 build-indep:
-	cd doc && $(MAKE) 
+	cd doc && $(MAKE)
 
 override_dh_auto_install:
 	# do nothing

## ocaml-visitors 20190711

=== debian/changelog ===
ocaml-visitors (20190711-2build1) eoan; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Sep 2019 19:01:08 +0200

ocaml-visitors (20190711-2) unstable; urgency=medium

  * Team upload
  * Fix overrides in debian/rules

 -- Stéphane Glondu <glondu@debian.org>  Thu, 12 Sep 2019 13:22:35 +0200

ocaml-visitors (20190711-1) unstable; urgency=medium

  * New upstream version.
  * Standards-Version 4.4.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Wed, 17 Jul 2019 22:52:52 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Build-Depends-Indep: texlive-latex-base, latexmk,
  lmodern, texlive-fonts-recommended, texlive-latex-extra,
  ocp-indent
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://gitlab.inria.fr/fpottier/visitors
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-visitors
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-visitors.git

=== debian/rules ===
--- 
+++ 
@@ -5,13 +5,10 @@
 %:
 	dh $@ --with ocaml
 
-override_dh_auto_build:
-	# do nothing
-
-build-arch:
+override_dh_auto_build-arch:
 	$(MAKE)
 
-build-indep:
+override_dh_auto_build-indep:
 	cd doc && $(MAKE)
 
 override_dh_auto_install:

## ocaml-visitors 20200210

=== doc/Makefile ===
export VISITORS_BUILDING_DOCUMENTATION=true

include ../Makefile.preprocess

export TEXINPUTS=.:../test:

.PHONY: all loop clean

all: manual.pdf

SOURCES   := $(wildcard *.tex) $(wildcard *.bib) $(wildcard *.sty)
ML        := $(shell ls ../test/*.ml | grep -v cppo | grep -v processed)
PROCESSED := $(patsubst %.ml,%.processed.ml,$(ML))

%.pdf: %.tex $(SOURCES) $(ML) $(PROCESSED)
	pdflatex $*
	bibtex $*
	pdflatex $*
	pdflatex $*

loop: $(SOURCES) $(ML) $(PROCESSED)
	latexmk -pdf -pvc manual

clean:
	rm -f *.log *.aux *.bbl *.blg *.out *.toc *~ manual.pdf

=== debian/changelog ===
ocaml-visitors (20200210-3) unstable; urgency=medium

  * Team upload
  * Call dune build with -p to avoid warnings-as-erros

 -- Stéphane Glondu <glondu@debian.org>  Thu, 15 Oct 2020 07:31:03 +0200

ocaml-visitors (20200210-2) unstable; urgency=medium

  * Team upload
  * Bump debhelper compat level to 13
  * Add Rules-Requires-Root: no
  * libppx-visitors-ocaml-doc: add Multi-Arch: foreign
  * debian/rules: include ocamlvars.mk to improve reproducibility

 -- Stéphane Glondu <glondu@debian.org>  Sun, 26 Jul 2020 08:31:28 +0200

ocaml-visitors (20200210-1) unstable; urgency=medium

  * New upstream release
  * Build-dependencies:
    - bump version of ocaml-nox
    - drop ocamlbuild and ocamlfind
    - add dune
    - add libppx-tools-ocaml-dev
    - bump version of libppx-deriving-ocaml-dev
    - add libresult-ocaml-dev
  * debian/rules: use dune to build and install
  * installation: update filename of the manual
  * override dh_missing to use the --fail-missing option
  * Standards-version 4.5.0 (no change)
  * Fix addresses in Vcs-{Git,Browser}
  * As-installed test: be more verbose

 -- Ralf Treinen <treinen@debian.org>  Tue, 11 Feb 2020 20:54:22 +0100

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,22 @@
 Priority: optional
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>,
-Build-Depends: debhelper-compat (= 12), dh-ocaml (>= 0.9~),
- ocaml-nox (>= 4.02.2), libfindlib-ocaml, cppo, ocamlbuild,
- libppx-deriving-ocaml-dev (>= 4.0)
+Build-Depends:
+ debhelper-compat (= 13),
+ dh-ocaml,
+ ocaml-nox,
+ cppo,
+ libppx-tools-ocaml-dev,
+ libppx-deriving-ocaml-dev (>= 4.4),
+ ocaml-dune (>= 2.0)
 Build-Depends-Indep: texlive-latex-base, latexmk,
  lmodern, texlive-fonts-recommended, texlive-latex-extra,
  ocp-indent
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://gitlab.inria.fr/fpottier/visitors
-Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-visitors
-Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-visitors.git
+Vcs-Browser: https://salsa.debian.org:ocaml-team/ocaml-visitors
+Vcs-Git: https://salsa.debian.org:ocaml-team/ocaml-visitors.git
 
 Package: libppx-visitors-ocaml-dev
 Architecture: any
@@ -30,6 +36,7 @@
 Package: libppx-visitors-ocaml-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Documentation of the visitors syntax extension for OCaml
  This package contains the documentation of the visitors syntax extension

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

DESTDIR = $(CURDIR)/debian/libppx-visitors-ocaml-dev/

%:
	dh $@ --with ocaml

override_dh_auto_build-arch:
	dune build -p visitors,visitors.runtime,visitors.ppx @install

override_dh_auto_build-indep:
	cd doc && $(MAKE)

override_dh_auto_install:
	# do nothing

override_dh_install-arch:
	mkdir -p $(DESTDIR)
	DESTDIR=$(DESTDIR) dune install
	# all useful docs are directly installed into the -doc package
	rm -r $(DESTDIR)/usr/doc

override_dh_install-indep:
	dh_installdocs -i

override_dh_auto_test:
	# do nothing

## ocaml-visitors 20210608

=== doc/Makefile ===
export VISITORS_BUILDING_DOCUMENTATION=true

include ../Makefile.preprocess

export TEXINPUTS=.:../test:../test/ppx_import:

SOURCEDIRS := ../test,../test/ppx_import
ML         := $(shell ls {$(SOURCEDIRS)}/*.ml | grep -v cppo | grep -v processed)
PROCESSED  := $(patsubst %.ml,%.processed.ml,$(ML))

.PHONY: all loop clean sources

all: sources
	latexmk -g -pdf manual

loop: sources
	latexmk -pdf -pvc manual

clean:
	rm -f *.log *.aux *.bbl *.blg *.out *.toc *~ manual.pdf

sources: $(wildcard *.tex) $(wildcard *.bib) $(wildcard *.sty) $(ML) $(PROCESSED)

=== debian/changelog ===
ocaml-visitors (20210608-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 21 Jan 2022 10:47:07 +0100

ocaml-visitors (20210127-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Bump Standards-Version to 4.6.0

 -- Stéphane Glondu <glondu@debian.org>  Tue, 23 Nov 2021 09:59:04 +0100

=== debian/control ===
--- 
+++ 
@@ -6,19 +6,22 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-ocaml,
- ocaml-nox,
- cppo,
- libppx-tools-ocaml-dev,
- libppx-deriving-ocaml-dev (>= 4.4),
+ ocaml,
+ libppxlib-ocaml-dev (>= 0.22.0),
+ libppx-deriving-ocaml-dev (>= 5.0),
  ocaml-dune (>= 2.0)
-Build-Depends-Indep: texlive-latex-base, latexmk,
- lmodern, texlive-fonts-recommended, texlive-latex-extra,
+Build-Depends-Indep:
+ texlive-latex-base,
+ latexmk,
+ lmodern,
+ texlive-fonts-recommended,
+ texlive-latex-extra,
  ocp-indent
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.inria.fr/fpottier/visitors
-Vcs-Browser: https://salsa.debian.org:ocaml-team/ocaml-visitors
-Vcs-Git: https://salsa.debian.org:ocaml-team/ocaml-visitors.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-visitors
+Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-visitors.git
 
 Package: libppx-visitors-ocaml-dev
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	dune build -p visitors,visitors.runtime,visitors.ppx @install
 
 override_dh_auto_build-indep:
-	cd doc && $(MAKE)
+	cd doc && $(MAKE) SHELL=/bin/bash
 
 override_dh_auto_install:
 	# do nothing

## ocaml-visitors 20250212

=== doc/Makefile ===
export VISITORS_BUILDING_DOCUMENTATION=true

include ../Makefile.preprocess

export TEXINPUTS=.:../test:../test/ppx_import:

SOURCEDIRS := ../test,../test/ppx_import
ML         := $(shell ls {$(SOURCEDIRS)}/*.ml | grep -v cppo | grep -v processed)
PROCESSED  := $(patsubst %.ml,%.processed.ml,$(ML))

.PHONY: all loop clean prerequisites sources

all: prerequisites
	make sources
	latexmk -g -pdf manual

loop: prerequisites
	make sources
	latexmk -pdf -pvc manual

clean:
	rm -f $(PROCESSED)
	git clean -fdX

# We need the following packages, plus visitors itself,
# which we install in the current switch.
prerequisites:
	opam install --yes ocamlfind ppx_import ppx_tools ocp-indent
	make -C .. install

sources: $(wildcard *.tex) $(wildcard *.bib) $(wildcard *.sty) $(ML) $(PROCESSED)

=== debian/changelog ===
ocaml-visitors (20250212-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 26 Feb 2025 08:49:14 +0100

ocaml-visitors (20210608-6) unstable; urgency=medium

  * Team upload
  * Add libresult-ocaml-dev to Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Tue, 04 Jun 2024 09:32:32 +0200

ocaml-visitors (20210608-5) unstable; urgency=medium

  * Team upload
  * Fix arch-indep build

 -- Stéphane Glondu <glondu@debian.org>  Thu, 17 Aug 2023 09:11:38 +0200

ocaml-visitors (20210608-4) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Use ocaml_dune DH buildsystem

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository, Repository-Browse.

 -- Stéphane Glondu <glondu@debian.org>  Thu, 17 Aug 2023 07:28:07 +0200

ocaml-visitors (20210608-3) unstable; urgency=medium

  * Fix installation directory.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 06 Jul 2023 10:53:36 +0200

ocaml-visitors (20210608-2) unstable; urgency=medium

  * Team upload.
  * Bump standards-version to 4.6.2.
  * Fix compilation with recent dune.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 04 Jul 2023 09:13:41 +0200

=== debian/tests/control ===
Tests: weight
Depends: @, ocaml-nox, libfindlib-ocaml, ocamlbuild

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
	 https://gitlab.inria.fr/fpottier/visitors.git \
         refs/tags/([\d]+)

## ocaml-visitors 20251010

=== doc/Makefile ===
export VISITORS_BUILDING_DOCUMENTATION=true

include ../Makefile.preprocess

# From test/ppx_import we read source files only, not preprocessed files.
# This allows us to build the manual without installing ppx_import, which
# is fortunate, as this package tends to be often late / unavailable.

export TEXINPUTS=.:../test:../test/ppx_import:

ML         := $(shell ls ../test/*.ml | grep -v cppo | grep -v processed)
PROCESSED  := $(patsubst %.ml,%.processed.ml,$(ML))

.PHONY: all loop clean prerequisites sources

all: prerequisites
	make sources
	latexmk -g -pdf manual

loop: prerequisites
	make sources
	latexmk -pdf -pvc manual

clean:
	rm -f $(PROCESSED)
	git clean -fdX

# We need the following packages, plus visitors itself,
# which we install in the current switch.
prerequisites:
	opam install --yes ocamlfind ppx_tools ocp-indent
	make -C .. install

sources: $(wildcard *.tex) $(wildcard *.bib) $(wildcard *.sty) $(ML) $(PROCESSED)

=== runtime/Makefile ===
.PHONY: all
all:
	@ make -C .. $@

=== src/Makefile ===
.PHONY: all
all:
	@ dune build @check

=== test/Makefile ===
.PHONY: test
test:
	@ make -C .. $@

=== test/bad/Makefile ===
.PHONY: test clean

test:
	cram -iv visitors.t

clean:
	rm -f visitors.t.err

=== debian/changelog ===
ocaml-visitors (20251010-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Switch debian/watch to version 5
  * Bump Standards-Version to 4.7.2
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Fri, 17 Oct 2025 08:37:33 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,11 @@
 Uploaders: Ralf Treinen <treinen@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
- dh-ocaml,
+ dh-ocaml (>= 1.2.2),
  ocaml,
  libppxlib-ocaml-dev (>= 0.22.0),
  libppx-deriving-ocaml-dev (>= 5.0),
+ libresult-ocaml-dev,
  ocaml-dune (>= 2.0)
 Build-Depends-Indep:
  texlive-latex-base,
@@ -16,9 +17,10 @@
  lmodern,
  texlive-fonts-recommended,
  texlive-latex-extra,
+ ocaml-findlib,
+ libppx-import-ocaml-dev,
  ocp-indent
-Standards-Version: 4.6.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: https://gitlab.inria.fr/fpottier/visitors
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-visitors
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-visitors.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml --buildsystem ocaml_dune

override_dh_auto_build-indep:
	cd doc && $(MAKE) SHELL=/bin/bash

override_dh_auto_install-indep:
# Do nothing

=== debian/watch ===
Version: 5

Source: https://gitlab.inria.fr/fpottier/visitors.git
Matching-Pattern: refs/tags/([\d]+)
Mode: git
Pgpmode: none

## ocaml-visitors 20251114

=== doc/Makefile ===
--- 
+++ 
@@ -11,15 +11,18 @@
 ML         := $(shell ls ../test/*.ml | grep -v cppo | grep -v processed)
 PROCESSED  := $(patsubst %.ml,%.processed.ml,$(ML))
 
-.PHONY: all loop clean prerequisites sources
+.PHONY: all loop view clean prerequisites sources
 
 all: prerequisites
 	make sources
-	latexmk -g -pdf manual
+	latexmk -pdf manual
 
 loop: prerequisites
 	make sources
 	latexmk -pdf -pvc manual
+
+view: all
+	open manual.pdf
 
 clean:
 	rm -f $(PROCESSED)
@@ -28,7 +31,8 @@
 # We need the following packages, plus visitors itself,
 # which we install in the current switch.
 prerequisites:
-	opam install --yes ocamlfind ppx_tools ocp-indent
-	make -C .. install
+	@ if ! command -v ocp-indent >/dev/null ; then \
+	  echo "Error: ocp-indent is not installed." ; exit 1 ; \
+	fi
 
 sources: $(wildcard *.tex) $(wildcard *.bib) $(wildcard *.sty) $(ML) $(PROCESSED)

=== debian/changelog ===
ocaml-visitors (20251114-1build5) resolute; urgency=medium

  * No change rebuild with fixed amd64v3 builders

 -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 27 Feb 2026 16:09:26 +0100

ocaml-visitors (20251114-1build4) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 25 Jan 2026 22:33:54 +0100

ocaml-visitors (20251114-1build3) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Dec 2025 20:59:18 +0100

ocaml-visitors (20251114-1build2) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Dec 2025 08:18:31 +0100

ocaml-visitors (20251114-1build1) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Dec 2025 07:07:27 +0100

ocaml-visitors (20251114-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 28 Nov 2025 08:54:37 +0100
